<template>
  <q-card
    flat
    class="rounded-borders-10"
    :class="{
      'q-pa-sm': screenWidth >= 768 && screenWidth <= 899,
      'q-pa-lg': screenWidth >= 900,
    }"
  >
    <q-card-section>
      <div class="row">
        <div class="col-3 q-my-auto">
          <label class="title-headline"> Education </label>
        </div>

        <q-spacer />

        <div class="col" align="right">
          <q-btn
            unelevated
            no-caps
            text
            label="Add"
            icon="add"
            class="btn-md text-primary rounded-borders-10"
            @click="showAddEducation(), (showAddDialog = true)"
          />
        </div>
      </div>
    </q-card-section>

    <q-card-section>
      <div
        class="row q-mb-lg"
        v-for="(education, k) in educationStore.educations"
        :key="k"
      >
        <div class="col-1 q-mr-xl">
          <p
            class="text-caption text-weight-bold text-grey-6 q-mt-xs"
            style="font-size: 11px"
          >
            SCHOOL
          </p>
          <p
            class="text-caption text-weight-bold text-grey-6 q-mt-xs"
            style="font-size: 11px"
          >
            YEAR
          </p>
          <p
            class="text-caption text-weight-bold text-grey-6 q-mt-xs"
            style="font-size: 11px"
          >
            LEVEL
          </p>
        </div>

        <div class="col">
          <p>{{ education.school_name }}</p>
          <p>{{ education.year_from + " - " + education.year_to }}</p>
          <p>{{ education.education_level.name }}</p>
        </div>

        <div class="col" align="right">
          <q-btn
            unelevated
            size="md"
            icon="eva-edit-outline"
            class="btn-edit q-mr-xs text-grey-6"
            @click="showEditEducation(education), (showEditDialog = true)"
          />

          <q-btn
            unelevated
            size="md"
            icon="eva-trash-outline"
            class="btn-edit text-grey-6"
            @click="
              showDeleteEducation(education.id), (showDeleteDialog = true)
            "
          />
        </div>
      </div>
    </q-card-section>
  </q-card>

  <!-- DIALOG: ADD EDUCATION  -->
  <q-dialog v-model="showAddDialog" persistent @hide="showAddDialog === false">
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 1300px; max-width: 90vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10">Add Education</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <q-form @submit="addDetails(form2)">
          <div id="form-details">
            <q-card
              v-for="(value, k) in form2.educations"
              :key="k"
              flat
              bordered
              class="q-pa-lg rounded-borders-10 q-mb-md"
            >
              <div
                v-if="form2.educations.length > 1"
                class="text-right text-negative"
              >
                <q-btn
                  unelevated
                  no-caps
                  label="Remove School"
                  text
                  icon="remove"
                  class="btn-md"
                  @click="removeRowEducation(k)"
                />
              </div>

              <div class="row">
                <div class="col q-mr-lg">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >YEAR (START) <span class="text-negative">*</span></label
                    >
                    <q-select
                      v-model="value.year_from"
                      :options="YEARS"
                      option-label="name"
                      option-value="id"
                      dense
                      outlined
                      class="q-mt-sm"
                      :rules="[validations.requiredField]"
                    />
                  </div>
                </div>

                <div class="col q-mr-lg">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >YEAR (END) <span class="text-negative">*</span></label
                    >
                    <q-select
                      v-model="value.year_to"
                      :options="YEARS"
                      option-label="name"
                      option-value="id"
                      dense
                      outlined
                      class="q-mt-sm"
                      :on-update:model-value="
                        greaterThanYearStart(value.year_from, value.year_to)
                      "
                      :rules="[validations.requiredField]"
                    />
                    <p
                      id="error"
                      class="q-field_messages text-negative q-pa-sm"
                      v-if="isError === true"
                    >
                      {{ errorMessage }}
                    </p>
                  </div>
                </div>

                <div class="col-5 q-mr-lg">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >SCHOOL <span class="text-negative">*</span></label
                    >
                    <q-input
                      v-model="value.school_name"
                      dense
                      outlined
                      class="q-mt-sm"
                      :rules="[validations.requiredField]"
                    />
                  </div>
                </div>

                <div class="col-3">
                  <div class="q-py-xs">
                    <label class="text-caption text-weight-bold text-grey-6"
                      >LEVEL <span class="text-negative">*</span></label
                    >
                    <q-select
                      v-model="value.education_level_id"
                      :options="referenceStore.levels"
                      option-label="name"
                      option-value="id"
                      map-options
                      emit-value
                      dense
                      outlined
                      class="q-mt-sm"
                      :rules="[validations.requiredField]"
                    />
                  </div>
                </div>
              </div>
            </q-card>

            <div class="text-right text-primary q-mt-md">
              <q-btn
                unelevated
                no-caps
                label="Add School"
                text
                icon="add"
                class="btn-md"
                @click="addRowEducation()"
              />
            </div>
          </div>

          <div class="q-mt-xl flex justify-center">
            <q-btn
              unelevated
              class="btn-lg btn--shade-1 text-white"
              type="submit"
              label="SUBMIT"
              :loading="loading"
            />
          </div>
        </q-form>
      </q-card-section>
    </q-card>
  </q-dialog>

  <!-- DIALOG: EDIT EDUCATION  -->
  <q-dialog
    v-model="showEditDialog"
    persistent
    @hide="showEditDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 1300px; max-width: 90vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10">Edit Education</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <q-form @submit="editDetails(form)">
          <div id="form-details">
            <div class="row">
              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >YEAR (START) <span class="text-negative">*</span></label
                  >
                  <q-select
                    v-model="form.year_from"
                    :options="YEARS"
                    option-label="name"
                    option-value="id"
                    dense
                    outlined
                    class="q-mt-sm"
                    :rules="[validations.requiredField]"
                  />
                </div>
              </div>

              <div class="col q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >YEAR (END) <span class="text-negative">*</span></label
                  >
                  <q-select
                    v-model="form.year_to"
                    :options="YEARS"
                    option-label="name"
                    option-value="id"
                    dense
                    outlined
                    class="q-mt-sm"
                    :on-update:model-value="
                      greaterThanYearStart(form.year_from, form.year_to)
                    "
                    :rules="[validations.requiredField]"
                  />
                  <p
                    id="error"
                    class="q-field_messages text-negative q-pa-sm"
                    v-if="isError === true"
                  >
                    {{ errorMessage }}
                  </p>
                </div>
              </div>

              <div class="col-5 q-mr-lg">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >SCHOOL <span class="text-negative">*</span></label
                  >
                  <q-input
                    v-model="form.school_name"
                    dense
                    outlined
                    class="q-mt-sm"
                    :rules="[validations.requiredField]"
                  />
                </div>
              </div>

              <div class="col-3">
                <div class="q-py-xs">
                  <label class="text-caption text-weight-bold text-grey-6"
                    >LEVEL <span class="text-negative">*</span></label
                  >
                  <q-select
                    v-model="form.education_level_id"
                    :options="referenceStore.levels"
                    option-label="name"
                    option-value="id"
                    map-options
                    emit-value
                    dense
                    outlined
                    class="q-mt-sm"
                    :rules="[validations.requiredField]"
                  />
                </div>
              </div>
            </div>
          </div>

          <div class="q-mt-xl flex justify-center">
            <q-btn
              unelevated
              class="btn-lg btn--shade-1 text-white"
              type="submit"
              label="SUBMIT"
              :loading="loading"
            />
          </div>
        </q-form>
      </q-card-section>
    </q-card>
  </q-dialog>

  <!-- DIALOG: DELETE EDUCATION  -->
  <q-dialog
    v-model="showDeleteDialog"
    persistent
    @hide="showDeleteDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 600px; max-width: 80vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10">Delete Education</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section class="q-pt-none">
        Are you sure you want to delete this entry?
      </q-card-section>

      <q-card-section>
        <div class="q-mt-xl flex justify-center">
          <q-btn
            class="btn-lg bg-negative text-white"
            :loading="deleteLoading"
            label="DELETE"
            @click="deleteDetails(form.id)"
          />
        </div>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<script>
import { defineComponent, ref, reactive, onMounted, onUnmounted } from "vue";
import { useEducation } from "../../store/education";
// import { useReference } from "../../store/reference";
import { useReference } from "src/modules/auth/store/reference";
import { requiredField } from "src/hooks/validations";
import useJobseekerHook from "../../hooks/jobseekerHook";

export default defineComponent({
  setup() {
    const educationStore = useEducation();
    const { getEducations, showEducation } = educationStore;

    const referenceStore = useReference();
    const { getLevels } = referenceStore;

    const screenWidth = ref(0);

    const {
      loading,
      deleteLoading,
      doCreateEducation,
      doUpdateEducation,
      doDeleteEducation,
    } = useJobseekerHook();
    const USER_ID = ref(null);
    const showAddDialog = ref(false);
    const showEditDialog = ref(false);
    const showDeleteDialog = ref(false);
    const YEARS = ref([]);
    const isError = ref(false);
    const errorMessage = ref("");

    const form = reactive({
      id: null,
      year_from: null,
      year_to: null,
      school_name: null,
      education_level_id: null,
    });

    const form2 = reactive({
      educations: [
        {
          year_from: "",
          year_to: "",
          school_name: "",
          education_level_id: "",
        },
      ],
    });

    const fetchUserDetails = async () => {
      await getEducations();
    };

    const generateArrayOfYears = () => {
      var max = new Date().getFullYear() + 8;
      var min = max - 70;
      var years = [];

      for (var i = max; i >= min; i--) {
        years.push(i.toString());
      }
      YEARS.value = years;
    };

    const greaterThanYearStart = (year_start, year_end) => {
      if (year_end && year_end < year_start) {
        isError.value = true;
        errorMessage.value =
          "Year (End) should be greater than or equal to Year (Start)";
      } else {
        isError.value = false;
      }
    };

    const addRowEducation = () => {
      form2.educations.push({
        year_from: "",
        year_to: "",
        school_name: null,
        education_level_id: null,
      });
    };

    const removeRowEducation = (index) => {
      form2.educations.splice(index, 1);
    };

    const showAddEducation = () => {
      form2.educations = [
        {
          year_from: "",
          year_to: "",
          school_name: null,
          education_level_id: null,
        },
      ];
    };

    const addDetails = async (form) => {
      await doCreateEducation(form);

      showAddDialog.value = false;
      fetchUserDetails();
    };

    const showEditEducation = (education) => {
      showEducation(education.id);

      form.id = education.id;
      form.year_from = education.year_from;
      form.year_to = education.year_to;
      form.school_name = education.school_name;
      form.education_level_id = education.education_level_id;
    };

    const editDetails = async (form) => {
      await doUpdateEducation(form.id, form);

      showEditDialog.value = false;
      fetchUserDetails();
    };

    const showDeleteEducation = (id) => {
      form.id = id;
      showDeleteDialog.value = true;
    };

    const deleteDetails = async (id) => {
      await doDeleteEducation(id);

      showDeleteDialog.value = false;
      fetchUserDetails();
    };

    onMounted(() => {
      window.addEventListener("resize", screenResize);
    });

    onUnmounted(() => {
      window.removeEventListener("resize", screenResize);
    });

    const screenResize = () => {
      screenWidth.value = window.innerWidth;
    };

    fetchUserDetails();
    generateArrayOfYears();
    getLevels();
    screenResize();

    return {
      educationStore,
      referenceStore,
      form,
      form2,
      YEARS,
      USER_ID,
      showAddDialog,
      showEditDialog,
      showDeleteDialog,
      loading,
      deleteLoading,
      isError,
      errorMessage,
      validations: {
        requiredField,
      },
      showAddEducation,
      showEditEducation,
      showDeleteEducation,
      addDetails,
      editDetails,
      deleteDetails,
      addRowEducation,
      removeRowEducation,
      greaterThanYearStart,
      screenResize,
      screenWidth,
    };
  },
});
</script>

<style lang="scss" scoped>
.btn-add {
  border-radius: 10px !important;
  padding: 5px !important;
}
.btn-edit {
  border-radius: 50px !important;
  padding: 5px !important;
}
</style>
